<template>
  <form @submit.prevent="procesar" autocomplete="off">
    <div class="row justify-content-center text-danger" v-if="errorMessage">
      {{errorMessage}}
    </div>
    <div class="form-group">
      <label for="nombre">Nombre</label>
      <input
        type="text"
        class="form-control"
        :class="{'is-valid': !$v.nombre.$invalid, 'is-invalid': $v.nombre.$invalid || (errors.nombre)}"
        placeholder="Nombre"
        v-model="$v.nombre.$model"
        @keypress="limpiarErrores('nombre')"
      >
      <div class="text-danger" v-if="!$v.nombre.required">
        El campo es requerido.
      </div>
      <div class="text-danger" v-if="!$v.nombre.minLength">
        El campo debe de tener al menos {{$v.nombre.$params.minLength.min}} caracteres.
      </div>
      <div class="text-danger" v-if="!$v.nombre.maxLength">
        El campo no debe tener mas de {{$v.nombre.$params.maxLength.max}}.
      </div>
      <div
        class="text-danger"
        v-for="(errorNombre, index) in errors.nombre"
        :key="index"
      >
        {{errorNombre}}
      </div>
    </div>
    <div class="form-group">
      <label for="alias">Alias</label>
      <input
        type="text"
        class="form-control"
        :class="{'is-valid': !$v.alias.$invalid, 'is-invalid': $v.alias.$invalid || errors.alias}"
        placeholder="Alias"
        v-model="$v.alias.$model"
        @keypress="limpiarErrores('alias')"
      >
      <div class="text-danger" v-if="!$v.alias.required">
        El campo es requerido.
      </div>
      <div class="text-danger" v-if="!$v.alias.minLength">
        El campo debe de tener al menos {{$v.alias.$params.minLength.min}} caracteres.
      </div>
      <div class="text-danger" v-if="!$v.alias.maxLength">
        El campo no debe tener mas de {{$v.alias.$params.maxLength.max}}.
      </div>
      <div
        class="text-danger"
        v-for="(errorAlias, index) in errors.alias"
        :key="index"
      >
        {{errorAlias}}
      </div>
    </div>
    <div class="form-group">
      <label for="especialidad">Especialidad</label>
      <input
        type="text"
        class="form-control"
        :class="{'is-valid': !$v.especialidad.$invalid, 'is-invalid': $v.especialidad.$invalid || errors.especialidad}"
        placeholder="Especialidad"
        v-model="$v.especialidad.$model"
        @keypress="limpiarErrores('especialidad')"
      >
      <div class="text-danger" v-if="!$v.especialidad.required">
        El campo es requerido.
      </div>
      <div class="text-danger" v-if="!$v.especialidad.minLength">
        El campo debe de tener al menos {{$v.especialidad.$params.minLength.min}} caracteres.
      </div>
      <div class="text-danger" v-if="!$v.especialidad.maxLength">
        El campo no debe tener mas de {{$v.especialidad.$params.maxLength.max}}.
      </div>
      <div
        class="text-danger"
        v-for="(errorEspecialidad, index) in errors.especialidad"
        :key="index"
      >
        {{errorEspecialidad}}
      </div>
    </div>
    <div class="form-group">
      <label for="ocupacion">Ocupacion</label>
      <select
        class="form-control"
        :class="{'is-valid': !$v.ocupacion.$invalid, 'is-invalid': $v.ocupacion.$invalid || errors.ocupacion}"
        v-model="$v.ocupacion.$model"
        @change="limpiarErrores('ocupacion')"
      >
        <option value="" hidden>Seleccione ocupacion</option>
        <option
          v-for="item in ocupacionSelect"
          :key="item.id"
          :value="item.id"
        >
          {{item.ocupacion}}
        </option>
      </select>
      <div class="text-danger" v-if="!$v.ocupacion.required">
        El campo es requerido.
      </div>
      <div
        class="text-danger"
        v-for="(errorOcupacion, index) in errors.ocupacion"
        :key="index"
      >
        {{errorOcupacion}}
      </div>
    </div>
    <div class="form-group">
      <label for="genero">Genero</label>
      <select
        class="form-control"
        :class="{'is-valid': !$v.genero.$invalid, 'is-invalid': $v.genero.$invalid || errors.genero}"
        v-model="$v.genero.$model"
        @change="limpiarErrores('genero')"
      >
        <option value="" hidden>Seleccione genero</option>
        <option
          v-for="item in generoSelect"
          :key="item.id"
          :value="item.id"
        >
          {{item.genero}}
        </option>
      </select>
      <div class="text-danger" v-if="!$v.genero.required">
        El campo es requerido.
      </div>
      <div
        class="text-danger"
        v-for="(errorGenero, index) in errors.genero"
        :key="index"
      >
        {{errorGenero}}
      </div>
    </div>
    <div class="row">
      <div class="col-6">
        <router-link
          class="btn btn-danger btn-block"
          :to="{name: 'Heroes'}"
        >
          Salir
        </router-link>
      </div>
      <div class="col-6">
        <button
          type="submit"
          :disabled="$v.$invalid || loading"
          class="btn btn-primary btn-block"
        >
          {{tituloBoton}}
        </button>
      </div>
    </div>
  </form>
</template>

<script>
import { required, minLength, maxLength, integer } from 'vuelidate/lib/validators'
import { mapState } from 'vuex'

export default {
  created() {
    this.getOcupacinoes()
    this.getGeneros()
  },
  data() {
    return {
      nombre: this.heroe?.nombre ? this.heroe.nombre : '',
      alias: this.heroe?.alias ? this.heroe.alias : '',
      especialidad: this.heroe?.especialidad ? this.heroe.especialidad : '',
      ocupacion: this.heroe?.ocupacion ? this.heroe.ocupacion : '',
      genero: this.heroe?.genero ? this.heroe.genero : '',
      ocupacionSelect: [],
      generoSelect: [],
      loading: false,
      errorMessage: '',
      errors: []
    }
  },
  props: {
    heroe: {}
  },
  methods: {
    getOcupacinoes() {
      let config = {
        headers: {
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token.token}`,
          'apikey': this.usuario.apikey
        }
      }
      this.axios.get('/v1/referentials/occupations', config)
        .then(result => {
          this.ocupacionSelect = result.data.body.ocupaciones
        })
    },
    getGeneros() {
      let config = {
        headers: {
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token.token}`,
          'apikey': this.usuario.apikey
        }
      }
      this.axios.get('/v1/referentials/genders', config)
        .then(result => {
          this.generoSelect = result.data.body.generos
        })
    },
    limpiarErrorMessage() {
      setTimeout(() => {
        this.errorMessage = ''
      }, 6000);
    },
    limpiarErrores(name) {
      delete this.errors[name]
    },
    procesar() {
      this.loading = true
      let data = {
        nombre: this.$v.nombre.$model,
        alias: this.$v.alias.$model,
        genero: this.$v.genero.$model,
        ocupacion: this.$v.ocupacion.$model,
        especialidad: this.$v.especialidad.$model,
      }
      let config = {
        headers: {
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token.token}`,
          'apikey': this.usuario.apikey
        }
      }

      if (this.heroe) {
        this.editar(config, data)
      }
      else {
        this.crear(config, data)
      }
    },
    crear(config, data) {
      this.axios.post('/v1/heroes', data, config)
        .then(result => {
          let codigos = [200, 201]
          this.loading = false
          Toast.fire({
            icon: 'success',
            title: result.data.message
          })
          if (codigos.includes(result.data.code)) {
            setTimeout(() => {
              this.$router.push({name: 'Heroes.detalle', params: {codigo: result.data.body.heroe.codigo}})
            }, 3000);
          }
          else {
            this.$router.push({name: 'Heroes'})
          }
        })
        .catch(e => {
          this.loading = false
          this.errorMessage = e.response.data.message
          this.errors = e.response.data.body?.errores ?? []
          this.limpiarErrorMessage()
        })
    },
    editar(config, data) {
      this.axios.put(`/v1/heroes/${this.heroe.codigo}`, data, config)
        .then(result => {
          this.loading = false
          let icon = result.data.message.includes('exitosa') ? 'success' : 'info'
          Toast.fire({
            icon: icon,
            title: result.data.message
          })
          setTimeout(() => {
            this.$router.push({name: 'Heroes.detalle', params: {codigo: this.heroe.codigo}})
          }, 3000);
        })
        .catch(e => {
          this.loading = false
          this.errorMessage = e.response.data.message
          this.errors = e.response.data.body?.errores ?? []
          this.limpiarErrorMessage()
        })
    }
  },
  computed: {
    ...mapState('usuario', ['usuario', 'token']),
    tituloBoton() {
      return this.heroe ? 'Editar' : 'Crear'
    }
  },
  validations: {
    nombre: {
      required,
      minLength: minLength(3),
      maxLength: maxLength(50)
    },
    alias: {
      required,
      minLength: minLength(3),
      maxLength: maxLength(50)
    },
    genero: {
      required,
      integer
    },
    ocupacion: {
      required,
      integer
    },
    especialidad: {
      required,
      minLength: minLength(3),
      maxLength: maxLength(200)
    }
  }
}
</script>
